'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _boardDrawer = require('./board-drawer.js');

var _boardDrawer2 = _interopRequireDefault(_boardDrawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Board draw's a Go Board
var Board = function (_React$PureComponent) {
  _inherits(Board, _React$PureComponent);

  function Board(props) {
    _classCallCheck(this, Board);

    var _this = _possibleConstructorReturn(this, (Board.__proto__ || Object.getPrototypeOf(Board)).call(this, props));

    var size = props.size,
        width = props.width,
        height = props.height;


    _this.drawer = new _boardDrawer2.default(size, width, height);
    return _this;
  }

  _createClass(Board, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          moves = _props.moves,
          width = _props.width,
          height = _props.height;

      var context = this.canvas.getContext('2d');

      this.canvas.width = width;
      this.canvas.height = height;

      if (context) {
        this.context = context;
        this.drawer.draw(this.context, moves);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var moves = nextProps.moves;


      if (this.context) {
        this.drawer.draw(this.context, moves);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement('canvas', { ref: function ref(c) {
          return _this2.canvas = c;
        } });
    }
  }]);

  return Board;
}(_react2.default.PureComponent);

Board.propTypes = {
  width: _react.PropTypes.number.isRequired,
  height: _react.PropTypes.number.isRequired,
  size: _react.PropTypes.number,
  moves: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    color: _react.PropTypes.oneOf(['B', 'W'])
  }))
};

Board.defaultProps = {
  size: 19,
  moves: []
};

exports.default = Board;